import numpy

path_to_goal = []
sample_move_grid = [[1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0],
                    [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 8, 1, 0],
                    [4, 6, 4, 4, 4, 4, 4, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0],
                    [1, 6, 1, 1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0],
                    [1, 6, 1, 1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0],
                    [4, 4, 4, 4, 4, 4, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 6, 4, 0],
                    [1, 1, 1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 1, 0],
                    [1, 1, 1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 1, 0],
                    [4, 4, 4, 4, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 6, 4, 4, 4, 0],
                    [1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 1, 1, 1, 0],
                    [1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 1, 1, 1, 0],
                    [4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4]]
visited = numpy.zeros_like(sample_move_grid)


def search_move_grid_dfs(move_grid, cur_r, cur_c, target):
    if cur_r < 0 or cur_c < 0 or cur_r > 11 or cur_c > 19:
        return
    # target_c -> found the goal! start backtrack
    # 0 -> always move left
    # 1 -> move only left and right (cannot go to 0)
    # 6 -> move only up or down (cannot go to 4)
    print(f"({cur_r:02d},{cur_c:02d}) = {move_grid[cur_r][cur_c]:d}")
    visited[cur_r][cur_c] = 1
    if move_grid[cur_r][cur_c] == target:
        print("TARGET REACHED!")
        return True
    elif move_grid[cur_r][cur_c] == 0:
        # try move left
        if not visited[cur_r][cur_c - 1]:
            res = search_move_grid_dfs(move_grid, cur_r, cur_c - 1, target)
            if res:
                print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) LEFT")
                return res
        return False
    elif move_grid[cur_r][cur_c] == 1:
        if move_grid[cur_r+1][cur_c] == 6:
            # am I at the top?
            # try move left
            if not visited[cur_r][cur_c - 1]:
                res = search_move_grid_dfs(move_grid, cur_r, cur_c - 1, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) LEFT")
                    return res
            # try move right
            if not visited[cur_r][cur_c + 1]:
                res = search_move_grid_dfs(move_grid, cur_r, cur_c + 1, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) RIGHT")
                    return res
            # try move down
            if not visited[cur_r + 1][cur_c]:
                res = search_move_grid_dfs(move_grid, cur_r + 1, cur_c, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) DOWN")
                    return res
            return False
        else:
            # try move left
            if not visited[cur_r][cur_c - 1]:
                res = search_move_grid_dfs(move_grid, cur_r, cur_c - 1, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) LEFT")
                    return res
            # try move right
            if not visited[cur_r][cur_c + 1]:
                res = search_move_grid_dfs(move_grid, cur_r, cur_c + 1, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) RIGHT")
                    return res
            return False
    elif move_grid[cur_r][cur_c] == 6:
        if move_grid[cur_r+1][cur_c] == 4:
            # am I at the floor?
            # try move left
            if not visited[cur_r][cur_c - 1]:
                res = search_move_grid_dfs(move_grid, cur_r, cur_c - 1, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) LEFT")
                    return res
            # try move right
            if not visited[cur_r][cur_c + 1]:
                res = search_move_grid_dfs(move_grid, cur_r, cur_c + 1, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) RIGHT")
                    return res
            # try move up
            if not visited[cur_r - 1][cur_c]:
                res = search_move_grid_dfs(move_grid, cur_r - 1, cur_c, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) UP")
                    return res
            return False
        else:
            # I am climbing...
            # try move up
            if not visited[cur_r - 1][cur_c]:
                res = search_move_grid_dfs(move_grid, cur_r - 1, cur_c, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) UP")
                    return res
            # try move down
            if not visited[cur_r + 1][cur_c]:
                res = search_move_grid_dfs(move_grid, cur_r + 1, cur_c, target)
                if res:
                    print(f"BACKTRACK: ({cur_r:02d},{cur_c:02d}) DOWN")
                    return res
            return False


if __name__ == "__main__":
    # initial = (10, 19)
    # target = 8
    search_move_grid_dfs(sample_move_grid, 10, 19, 8)


